<?php

namespace App\Models;

use Illuminate\Support\Str;

use Spatie\Permission\Traits\HasRoles;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Notifications\Notifiable;
use Illuminate\Database\Eloquent\SoftDeletes;
use Deligoez\LaravelModelHashId\Traits\HasHashId;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Product extends Model
{

    /** @use HasFactory<\Database\Factories\UserFactory> */
    use HasFactory, Notifiable, HasHashId, HasRoles, SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var list<string>
     */
    protected $guarded = [];

    /**
     * Relations
     */

    // Catégorie du produit
    public function category()
    {
        return $this->belongsTo(Category::class);
    }

    // Fournisseur du produit
    public function supplier()
    {
        return $this->belongsTo(Supplier::class);
    }

    // Unité de mesure du produit
    public function unit()
    {
        return $this->belongsTo(Unit::class);
    }

    // Utilisateur qui a créé le produit
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    // Stocks du produit
    public function stocks()
    {
        return $this->hasMany(Stock::class);
    }

    // Mouvements de stock du produit
    public function movementStocks()
    {
        return $this->hasMany(MovementStock::class);
    }

    // Détails de demandes contenant ce produit
    public function requestDetails()
    {
        return $this->hasMany(RequestDetail::class);
    }

    // Équipements associés à ce produit
    public function equipment()
    {
        return $this->hasMany(Equipment::class);
    }

    //Génération automatique de la référence unique pour les produits
    protected static function booted()
    {
        static::creating(function ($product) {
            $product->reference = 'PRD-00' . strtoupper(Str::random(2));
        });
    }
}